//+------------------------------------------------------------------+
//|                                           OnChart Stochastic.mq4 |
//|                                                           mladen |
//|                                                                  |
//| idea for this indicator by fxbs                                  |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      ""

#property indicator_chart_window
#property indicator_buffers 5
#property indicator_color1 DarkSlateGray
#property indicator_color2 DarkSlateGray
#property indicator_color3 DarkSlateGray
#property indicator_color4 DeepSkyBlue
#property indicator_width4 2
#property indicator_color5 Red
#property indicator_style1 STYLE_DOT
#property indicator_style5 STYLE_DOT

//
//
//
//
//

extern int    KPeriod     = 14;
extern int    Slowing     =  3;
extern int    DPeriod     =  3;
extern int    PriceField  =  1;
extern int    maPeriod    = 20;
extern int    maMethod    =  1;
extern int    maPrice     =  0;
extern int    overBought  = 80;
extern int    overSold    = 20;
extern string timeFrame   = "Current time frame";
extern bool   interpolate = true;

//
//
//
//
//

double ExtMapBuffer1[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];
double ExtMapBuffer4[];
double ExtMapBuffer5[];
int    TimeFrame;
int    atrTimeFrame;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexBuffer(1,ExtMapBuffer2);
   SetIndexBuffer(2,ExtMapBuffer3);
   SetIndexBuffer(3,ExtMapBuffer4);
   SetIndexBuffer(4,ExtMapBuffer5);

   //
   //
   //
   //
   //
   
   TimeFrame = stringToTimeFrame(timeFrame);
   atrTimeFrame=PERIOD_D1;
   if (TimeFrame >= atrTimeFrame)
      switch (TimeFrame)
         {
            case PERIOD_D1: atrTimeFrame = PERIOD_W1; break;
            default:        atrTimeFrame = PERIOD_MN1;
         }
   return(0);
}
int deinit() { return(0); }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int limit,i;
   
   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
      limit=MathMax(MathMin(Bars-counted_bars,Bars-1),TimeFrame/Period());   
      

   //
   //
   //
   //
   //
   
      for (i=limit; i>=0; i--)
      {
         int y = iBarShift(NULL,TimeFrame   ,Time[i]);
         int r = iBarShift(NULL,atrTimeFrame,Time[i]);
            double avgRange   = iATR(NULL,atrTimeFrame,maPeriod,r);
            double maValue    = iMA(NULL,TimeFrame,maPeriod,0,maMethod,maPrice,y);
            double stochValue = iStochastic(NULL,TimeFrame,KPeriod,DPeriod,Slowing,maMethod,PriceField,MODE_MAIN,  y);
               
            //
            //
            //
            //
            //
               
            ExtMapBuffer1[i] = maValue;
            ExtMapBuffer2[i] = maValue+(avgRange*(overBought-50)/100);
            ExtMapBuffer3[i] = maValue-(avgRange*(50-  overSold)/100);
            ExtMapBuffer4[i] = maValue+(stochValue -50)/100*avgRange;
            if (DPeriod>1)
               ExtMapBuffer5[i] = maValue+(iStochastic(NULL,TimeFrame,KPeriod,DPeriod,Slowing,maMethod,PriceField,MODE_SIGNAL,y)-50)/100*avgRange;
               
            //
            //
            //
            //
            //
               
            if (TimeFrame <= Period() || y==iBarShift(NULL,TimeFrame,Time[i-1])) continue;
            if (!interpolate) continue;
        
            //    
            //
            //
            //
            //

            datetime	time = iTime(NULL,TimeFrame,y);
            for(int n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;	
              double factor = 1.0 / n;
              for(int k = 1; k < n; k++)
              {
                 ExtMapBuffer1[i+k] = k*factor*ExtMapBuffer1[i+n] + (1.0-k*factor)*ExtMapBuffer1[i];
                 ExtMapBuffer2[i+k] = k*factor*ExtMapBuffer2[i+n] + (1.0-k*factor)*ExtMapBuffer2[i];
                 ExtMapBuffer3[i+k] = k*factor*ExtMapBuffer3[i+n] + (1.0-k*factor)*ExtMapBuffer3[i];
                 ExtMapBuffer4[i+k] = k*factor*ExtMapBuffer4[i+n] + (1.0-k*factor)*ExtMapBuffer4[i];
                        
                 //
                 //
                 //
                 //
                 //
                        
                 if (DPeriod>1)
                    ExtMapBuffer5[i+k] = k*factor*ExtMapBuffer5[i+n] + (1.0-k*factor)*ExtMapBuffer5[i];
              }             
         }
   
   //
   //
   //
   //
   //
         
   return(0);
}

//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   int tf=0;
       tfs = StringUpperCase(tfs);
         if (tfs=="M1" || tfs=="1")     tf=PERIOD_M1;
         if (tfs=="M5" || tfs=="5")     tf=PERIOD_M5;
         if (tfs=="M15"|| tfs=="15")    tf=PERIOD_M15;
         if (tfs=="M30"|| tfs=="30")    tf=PERIOD_M30;
         if (tfs=="H1" || tfs=="60")    tf=PERIOD_H1;
         if (tfs=="H4" || tfs=="240")   tf=PERIOD_H4;
         if (tfs=="D1" || tfs=="1440")  tf=PERIOD_D1;
         if (tfs=="W1" || tfs=="10080") tf=PERIOD_W1;
         if (tfs=="MN" || tfs=="43200") tf=PERIOD_MN1;
         if (tf<Period()) tf=Period();
  return(tf);
}

//
//
//
//
//

string StringUpperCase(string str)
{
   string   s = str;
   int      lenght = StringLen(str) - 1;
   int      char;
   
   while(lenght >= 0)
      {
         char = StringGetChar(s, lenght);
         
         //
         //
         //
         //
         //
         
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                  s = StringSetChar(s, lenght, char - 32);
          else 
              if(char > -33 && char < 0)
                  s = StringSetChar(s, lenght, char + 224);
                  
         //
         //
         //
         //
         //
                                 
         lenght--;
   }
   
   //
   //
   //
   //
   //
   
   return(s);
}